import { CUSTOM_ELEMENTS_SCHEMA, NgModule } from '@angular/core';
import { CommonModule } from '@angular/common';
import { TariffRoutingModule } from './tariff-routing.module';
import { TariffComponent } from './tariff/tariff.component';
import { UsermanagementModule } from '../usermanagement/usermanagement.module';
import { SharedModule } from '../shared/shared.module';
import { FormsModule, ReactiveFormsModule } from '@angular/forms';
import { NgxPaginationModule } from 'ngx-pagination';
import { Ng2SearchPipeModule } from 'ng2-search-filter';
import { NgbModule } from '@ng-bootstrap/ng-bootstrap';
import { ListComponent } from './list/list.component';
import {NotificationModule} from '../shared/notification/notification.module'
import { RatelistComponent } from './ratelist/ratelist.component';
//  import { AlertComponent } from '../shared/alert/alert.component';
import {MatExpansionModule} from '@angular/material/expansion';
import { TollfreeratesComponent } from './tollfreerates/tollfreerates.component';
import { EditTariffComponent } from './edit-tariff/edit-tariff.component';
import { MatTooltipModule } from '@angular/material/tooltip';
import { AddtariffComponent } from './unregistered/addtariff/addtariff.component';
import { UnregisteredComponent } from './unregistered/unregistered/unregistered.component';
import { EdittariffComponent } from './unregistered/edittariff/edittariff.component';
import { SurchargeComponent } from './surcharge/surcharge.component';
import { AddsurchargeComponent } from './addsurcharge/addsurcharge.component';
import { ServiceComponent } from './service/service.component';
import { AddServiceComponent } from './add-service/add-service.component';
import { NgMultiSelectDropDownModule } from 'ng-multiselect-dropdown';
import { AdvanceratesComponent } from './advancerates/advancerates.component';
import { LerginfoComponent } from './lerginfo/lerginfo.component';
import { OperatorMappingComponent } from './operator-mapping/operator-mapping.component';
import { ZoneComponent } from './zone/zone.component';
import { ClonetariffComponent } from './unregistered/clonetariff/clonetariff.component';
import { MatSlideToggleModule } from '@angular/material/slide-toggle';

@NgModule({
  declarations: [TariffComponent, ListComponent, RatelistComponent, TollfreeratesComponent, EditTariffComponent, AddtariffComponent, UnregisteredComponent, EdittariffComponent, SurchargeComponent, AddsurchargeComponent, ServiceComponent, AddServiceComponent, AdvanceratesComponent, LerginfoComponent, OperatorMappingComponent, ZoneComponent, ClonetariffComponent],
  imports: [
    CommonModule,
    TariffRoutingModule,
    UsermanagementModule,
    ReactiveFormsModule,
    SharedModule,
    NgxPaginationModule,
    FormsModule,
    Ng2SearchPipeModule,
    NotificationModule,
    NgbModule,  
    MatTooltipModule,
    MatExpansionModule,
    MatSlideToggleModule,
    NgMultiSelectDropDownModule.forRoot(),
  ],
  schemas: [CUSTOM_ELEMENTS_SCHEMA]
})
export class TariffModule { }
